Subject: Re: bug#13816: 24.3.50; turn-on-font-lock doesn't turn it on

From: Katsumi Yamaoka <[email-masked]>
Date: Tue, 26 Feb 2013 16:29:25 +0900

Stefan Monnier wrote:
>> Recently turn-on-font-lock set to some hook turns font-lock
>> on but turns it off immediately regardless of the value of
>> global-font-lock-mode.  Here's a recipe:

>> emacs -Q
>> Eval: (add-hook 'emacs-lisp-mode-hook 'turn-on-font-lock)
>> and visit some .el file.

> Works fine on the trunk right now.  Can you confirm it was fixed if you
> try a recent enough build?

I build Emacs from the trunk almost everyday.  Now I use:

In GNU Emacs 24.3.50.1 (i686-pc-cygwin, X toolkit, Xaw3d scroll bars)
 of 2013-02-26 on localhost
Bzr revision: 111880 [email-masked]
Windowing system distributor `The Cygwin/X Project', version 11.0.11302000
Configured using:
 `configure --verbose --with-x-toolkit=lucid --without-imagemagick
 --without-dbus --without-gconf --without-gsettings'

I've reverted the 111870 change because of bug#13818, though.

According to my tracing of run-mode-hooks, it turns on font-lock
but turns it off by the last line:

(defun run-mode-hooks (&rest hooks)
[...]
    ;; ON
    (apply 'run-hooks (cons 'change-major-mode-after-body-hook hooks))
    ;; OFF
    (run-hooks 'after-change-major-mode-hook)))